<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!--NewPage-->
<HTML>
<HEAD>
<!-- Generated by javadoc (build 1.6.0_35) on Sun Jan 20 22:40:32 CET 2013 -->
<META http-equiv="Content-Type" content="text/html; charset=UTF-8">
<TITLE>
org.apache.http.conn (HttpComponents Client 4.3-alpha1 API)
</TITLE>

<META NAME="date" CONTENT="2013-01-20">

<LINK REL ="stylesheet" TYPE="text/css" HREF="../../../../stylesheet.css" TITLE="Style">

<SCRIPT type="text/javascript">
function windowTitle()
{
    if (location.href.indexOf('is-external=true') == -1) {
        parent.document.title="org.apache.http.conn (HttpComponents Client 4.3-alpha1 API)";
    }
}
</SCRIPT>
<NOSCRIPT>
</NOSCRIPT>

</HEAD>

<BODY BGCOLOR="white" onload="windowTitle();">
<HR>


<!-- ========= START OF TOP NAVBAR ======= -->
<A NAME="navbar_top"><!-- --></A>
<A HREF="#skip-navbar_top" title="Skip navigation links"></A>
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0" SUMMARY="">
<TR>
<TD COLSPAN=2 BGCOLOR="#EEEEFF" CLASS="NavBarCell1">
<A NAME="navbar_top_firstrow"><!-- --></A>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3" SUMMARY="">
  <TR ALIGN="center" VALIGN="top">
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> &nbsp;<FONT CLASS="NavBarFont1Rev"><B>Package</B></FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <FONT CLASS="NavBarFont1">Class</FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-use.html"><FONT CLASS="NavBarFont1"><B>Use</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../index-all.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A>&nbsp;</TD>
  </TR>
</TABLE>
</TD>
<TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM>
</EM>
</TD>
</TR>

<TR>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
&nbsp;<A HREF="../../../../org/apache/http/client/utils/package-summary.html"><B>PREV PACKAGE</B></A>&nbsp;
&nbsp;<A HREF="../../../../org/apache/http/conn/params/package-summary.html"><B>NEXT PACKAGE</B></A></FONT></TD>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
  <A HREF="../../../../index.html?org/apache/http/conn/package-summary.html" target="_top"><B>FRAMES</B></A>  &nbsp;
&nbsp;<A HREF="package-summary.html" target="_top"><B>NO FRAMES</B></A>  &nbsp;
&nbsp;<SCRIPT type="text/javascript">
  <!--
  if(window==top) {
    document.writeln('<A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>');
  }
  //-->
</SCRIPT>
<NOSCRIPT>
  <A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>
</NOSCRIPT>


</FONT></TD>
</TR>
</TABLE>
<A NAME="skip-navbar_top"></A>
<!-- ========= END OF TOP NAVBAR ========= -->

<HR>
<H2>
Package org.apache.http.conn
</H2>
The client-side connection management and handling API that provides interfaces
and implementations for opening and managing client side HTTP connections.
<P>
<B>See:</B>
<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<A HREF="#package_description"><B>Description</B></A>
<P>

<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Interface Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../org/apache/http/conn/ClientConnectionManager.html" title="interface in org.apache.http.conn">ClientConnectionManager</A></B></TD>
<TD><B>Deprecated.</B>&nbsp;<I>(4.3) replaced by <A HREF="../../../../org/apache/http/conn/HttpClientConnectionManager.html" title="interface in org.apache.http.conn"><CODE>HttpClientConnectionManager</CODE></A>.</I></TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../org/apache/http/conn/ClientConnectionManagerFactory.html" title="interface in org.apache.http.conn">ClientConnectionManagerFactory</A></B></TD>
<TD><B>Deprecated.</B>&nbsp;<I>(4.3) replaced by <A HREF="../../../../org/apache/http/conn/HttpClientConnectionManager.html" title="interface in org.apache.http.conn"><CODE>HttpClientConnectionManager</CODE></A>.</I></TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../org/apache/http/conn/ClientConnectionOperator.html" title="interface in org.apache.http.conn">ClientConnectionOperator</A></B></TD>
<TD><B>Deprecated.</B>&nbsp;<I>(4.3) replaced by <A HREF="../../../../org/apache/http/conn/HttpClientConnectionManager.html" title="interface in org.apache.http.conn"><CODE>HttpClientConnectionManager</CODE></A>.</I></TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../org/apache/http/conn/ClientConnectionRequest.html" title="interface in org.apache.http.conn">ClientConnectionRequest</A></B></TD>
<TD><B>Deprecated.</B>&nbsp;<I>(4.3) replaced by <A HREF="../../../../org/apache/http/conn/ConnectionRequest.html" title="interface in org.apache.http.conn"><CODE>ConnectionRequest</CODE></A>.</I></TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../org/apache/http/conn/ConnectionKeepAliveStrategy.html" title="interface in org.apache.http.conn">ConnectionKeepAliveStrategy</A></B></TD>
<TD>Interface for deciding how long a connection can remain
 idle before being reused.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../org/apache/http/conn/ConnectionReleaseTrigger.html" title="interface in org.apache.http.conn">ConnectionReleaseTrigger</A></B></TD>
<TD>Interface for releasing a connection.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../org/apache/http/conn/ConnectionRequest.html" title="interface in org.apache.http.conn">ConnectionRequest</A></B></TD>
<TD>Encapsulates a request for a <A HREF="http://hc.apache.org/httpcomponents-core-ga/httpcore/apidocs/org/apache/http/HttpClientConnection.html?is-external=true" title="class or interface in org.apache.http"><CODE>HttpClientConnection</CODE></A>.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../org/apache/http/conn/DnsResolver.html" title="interface in org.apache.http.conn">DnsResolver</A></B></TD>
<TD>Users may implement this interface to override the normal DNS lookup offered
 by the OS.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../org/apache/http/conn/EofSensorWatcher.html" title="interface in org.apache.http.conn">EofSensorWatcher</A></B></TD>
<TD>A watcher for <A HREF="../../../../org/apache/http/conn/EofSensorInputStream.html" title="class in org.apache.http.conn"><CODE>EofSensorInputStream</CODE></A>.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../org/apache/http/conn/HttpClientConnectionManager.html" title="interface in org.apache.http.conn">HttpClientConnectionManager</A></B></TD>
<TD>Represents a manager of persistent client connections.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../org/apache/http/conn/HttpConnectionFactory.html" title="interface in org.apache.http.conn">HttpConnectionFactory&lt;T extends HttpConnection&gt;</A></B></TD>
<TD>Generic <A HREF="http://hc.apache.org/httpcomponents-core-ga/httpcore/apidocs/org/apache/http/HttpConnection.html?is-external=true" title="class or interface in org.apache.http"><CODE>HttpConnection</CODE></A> factory.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../org/apache/http/conn/HttpRoutedConnection.html" title="interface in org.apache.http.conn">HttpRoutedConnection</A></B></TD>
<TD><B>Deprecated.</B>&nbsp;<I>(4.3) replaced by <A HREF="../../../../org/apache/http/conn/HttpClientConnectionManager.html" title="interface in org.apache.http.conn"><CODE>HttpClientConnectionManager</CODE></A>.</I></TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../org/apache/http/conn/ManagedClientConnection.html" title="interface in org.apache.http.conn">ManagedClientConnection</A></B></TD>
<TD><B>Deprecated.</B>&nbsp;<I>(4.3) replaced by <A HREF="../../../../org/apache/http/conn/HttpClientConnectionManager.html" title="interface in org.apache.http.conn"><CODE>HttpClientConnectionManager</CODE></A>.</I></TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../org/apache/http/conn/OperatedClientConnection.html" title="interface in org.apache.http.conn">OperatedClientConnection</A></B></TD>
<TD><B>Deprecated.</B>&nbsp;<I>(4.3) replaced by <A HREF="../../../../org/apache/http/conn/HttpClientConnectionManager.html" title="interface in org.apache.http.conn"><CODE>HttpClientConnectionManager</CODE></A>.</I></TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../org/apache/http/conn/SchemePortResolver.html" title="interface in org.apache.http.conn">SchemePortResolver</A></B></TD>
<TD>Default port resolver for protocol schemes.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../org/apache/http/conn/SocketClientConnection.html" title="interface in org.apache.http.conn">SocketClientConnection</A></B></TD>
<TD>Extended interface that exposes <A HREF="http://download.oracle.com/javase/1.5.0/docs/api/java/net/Socket.html?is-external=true" title="class or interface in java.net"><CODE>Socket</CODE></A> bind method and SSL session details.</TD>
</TR>
</TABLE>
&nbsp;

<P>

<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Class Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../org/apache/http/conn/BasicEofSensorWatcher.html" title="class in org.apache.http.conn">BasicEofSensorWatcher</A></B></TD>
<TD><B>Deprecated.</B>&nbsp;<I>(4.3) do not use.</I></TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../org/apache/http/conn/BasicManagedEntity.html" title="class in org.apache.http.conn">BasicManagedEntity</A></B></TD>
<TD><B>Deprecated.</B>&nbsp;<I>(4.3) do not use.</I></TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../org/apache/http/conn/EofSensorInputStream.html" title="class in org.apache.http.conn">EofSensorInputStream</A></B></TD>
<TD>A stream wrapper that triggers actions on <A HREF="../../../../org/apache/http/conn/EofSensorInputStream.html#close()"><CODE>close()</CODE></A> and EOF.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../org/apache/http/conn/HttpInetSocketAddress.html" title="class in org.apache.http.conn">HttpInetSocketAddress</A></B></TD>
<TD><B>Deprecated.</B>&nbsp;<I>(4.3)</I></TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../org/apache/http/conn/MultihomePlainSocketFactory.html" title="class in org.apache.http.conn">MultihomePlainSocketFactory</A></B></TD>
<TD><B>Deprecated.</B>&nbsp;<I>(4.1)  Do not use.</I></TD>
</TR>
</TABLE>
&nbsp;

<P>

<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Exception Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../org/apache/http/conn/ConnectionPoolTimeoutException.html" title="class in org.apache.http.conn">ConnectionPoolTimeoutException</A></B></TD>
<TD>A timeout while waiting for an available connection
 from a connection manager.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../org/apache/http/conn/ConnectTimeoutException.html" title="class in org.apache.http.conn">ConnectTimeoutException</A></B></TD>
<TD>A timeout while connecting to an HTTP server or waiting for an
 available connection from an HttpConnectionManager.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD WIDTH="15%"><B><A HREF="../../../../org/apache/http/conn/HttpHostConnectException.html" title="class in org.apache.http.conn">HttpHostConnectException</A></B></TD>
<TD>A <A HREF="http://download.oracle.com/javase/1.5.0/docs/api/java/net/ConnectException.html?is-external=true" title="class or interface in java.net"><CODE>ConnectException</CODE></A> that specifies the <A HREF="http://hc.apache.org/httpcomponents-core-ga/httpcore/apidocs/org/apache/http/HttpHost.html?is-external=true" title="class or interface in org.apache.http"><CODE>HttpHost</CODE></A> that was
 being connected to.</TD>
</TR>
</TABLE>
&nbsp;

<P>
<A NAME="package_description"><!-- --></A><H2>
Package org.apache.http.conn Description
</H2>

<P>
The client-side connection management and handling API that provides interfaces
and implementations for opening and managing client side HTTP connections.
<p>
The lowest layer of connection handling is comprised of
<A HREF="../../../../org/apache/http/conn/OperatedClientConnection.html" title="interface in org.apache.http.conn"><CODE>OperatedClientConnection</CODE></A>
and
<A HREF="../../../../org/apache/http/conn/ClientConnectionOperator.html" title="interface in org.apache.http.conn"><CODE>ClientConnectionOperator</CODE></A>.
The connection interface extends the core
<A HREF="http://hc.apache.org/httpcomponents-core-ga/httpcore/apidocs/org/apache/http/HttpClientConnection.html?is-external=true" title="class or interface in org.apache.http"><CODE>HttpClientConnection</CODE></A>
by operations to set and update a socket. An operator encapsulates the logic to
open and layer sockets, typically using a
<A HREF="../../../../org/apache/http/conn/scheme/SocketFactory.html" title="interface in org.apache.http.conn.scheme"><CODE>SocketFactory</CODE></A>. The socket factory for
a protocol <A HREF="../../../../org/apache/http/conn/scheme/Scheme.html" title="class in org.apache.http.conn.scheme"><CODE>Scheme</CODE></A> such as "http" or "https"
can be looked up in a <A HREF="../../../../org/apache/http/conn/scheme/SchemeRegistry.html" title="class in org.apache.http.conn.scheme"><CODE>SchemeRegistry</CODE></A>.
Applications without a need for sophisticated connection management can use
this layer directly.
</p>
<p>
On top of that lies the connection management layer. A
<A HREF="../../../../org/apache/http/conn/ClientConnectionManager.html" title="interface in org.apache.http.conn"><CODE>ClientConnectionManager</CODE></A> internally manages
operated connections, but hands out instances of
<A HREF="../../../../org/apache/http/conn/ManagedClientConnection.html" title="interface in org.apache.http.conn"><CODE>ManagedClientConnection</CODE></A>.
This interface abstracts from the underlying socket operations and
provides convenient methods for opening and updating sockets in order
to establish a <A HREF="../../../../org/apache/http/conn/routing/HttpRoute.html" title="class in org.apache.http.conn.routing"><CODE>route</CODE></A>.
The operator is encapsulated by the connection manager and called
automatically.
</p>
<p>
Connections obtained from a manager have to be returned after use.
This can be <A HREF="../../../../org/apache/http/conn/ConnectionReleaseTrigger.html" title="interface in org.apache.http.conn"><CODE>triggered</CODE></A>
on various levels, either by releasing the
<A HREF="../../../../org/apache/http/conn/ManagedClientConnection.html" title="interface in org.apache.http.conn"><CODE>connection</CODE></A> directly,
or by calling a method on
an <A HREF="../../../../org/apache/http/conn/BasicManagedEntity.html" title="class in org.apache.http.conn"><CODE>entity</CODE></A> received from
the connection, or by closing the
<A HREF="../../../../org/apache/http/conn/EofSensorInputStream.html" title="class in org.apache.http.conn"><CODE>stream</CODE></A> from which
that entity is being read.
</p>
<p>
Connection managers will try to keep returned connections alive in
order to re-use them for subsequent requests along the same route.
The managed connection interface and all triggers for connection release
provide methods to enable or disable this behavior.
</p>
<P>

<P>
<DL>
</DL>
<HR>


<!-- ======= START OF BOTTOM NAVBAR ====== -->
<A NAME="navbar_bottom"><!-- --></A>
<A HREF="#skip-navbar_bottom" title="Skip navigation links"></A>
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0" SUMMARY="">
<TR>
<TD COLSPAN=2 BGCOLOR="#EEEEFF" CLASS="NavBarCell1">
<A NAME="navbar_bottom_firstrow"><!-- --></A>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3" SUMMARY="">
  <TR ALIGN="center" VALIGN="top">
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> &nbsp;<FONT CLASS="NavBarFont1Rev"><B>Package</B></FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <FONT CLASS="NavBarFont1">Class</FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-use.html"><FONT CLASS="NavBarFont1"><B>Use</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../index-all.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A>&nbsp;</TD>
  </TR>
</TABLE>
</TD>
<TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM>
</EM>
</TD>
</TR>

<TR>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
&nbsp;<A HREF="../../../../org/apache/http/client/utils/package-summary.html"><B>PREV PACKAGE</B></A>&nbsp;
&nbsp;<A HREF="../../../../org/apache/http/conn/params/package-summary.html"><B>NEXT PACKAGE</B></A></FONT></TD>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
  <A HREF="../../../../index.html?org/apache/http/conn/package-summary.html" target="_top"><B>FRAMES</B></A>  &nbsp;
&nbsp;<A HREF="package-summary.html" target="_top"><B>NO FRAMES</B></A>  &nbsp;
&nbsp;<SCRIPT type="text/javascript">
  <!--
  if(window==top) {
    document.writeln('<A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>');
  }
  //-->
</SCRIPT>
<NOSCRIPT>
  <A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>
</NOSCRIPT>


</FONT></TD>
</TR>
</TABLE>
<A NAME="skip-navbar_bottom"></A>
<!-- ======== END OF BOTTOM NAVBAR ======= -->

<HR>
Copyright &#169; 1999-2013 <a href="http://www.apache.org/">The Apache Software Foundation</a>. All Rights Reserved.
</BODY>
</HTML>
